/***************************************************************************
 *   Copyright (C) 2006 by George Kiagiadakis   *
 *   gkiagia@users.sourceforge.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CONFIGURATION_H
#define CONFIGURATION_H

#include <QDir>
#include <QString>
#include <QSettings>

class Configuration : public QDir
{

public:
	Configuration(const QString &path, QString name);
	~Configuration();
	QString name() const;
	bool isSymlink() const;
	QString description();
	void setDescription(QString d);
	bool rmSelf();
	void renameSelf(QString newName);
	bool update();
	void personalize();

private:
	bool recursiveRmDir(QDir dir);
	void fixDriveC();
	QSettings *cfgSettings;
	QString cfgName;
	bool symlink;
};

#endif
